VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "34"
   ClientHeight    =   7905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9885
   LinkTopic       =   "Form1"
   ScaleHeight     =   527
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   659
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   495
      Left            =   8520
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Ulozit"
      Height          =   495
      Left            =   7200
      TabIndex        =   4
      Top             =   7320
      Width           =   2535
   End
   Begin VB.ListBox lstResult 
      Height          =   6495
      Left            =   7200
      TabIndex        =   3
      Top             =   720
      Width           =   2535
   End
   Begin VB.CommandButton cmdS 
      Caption         =   "Najit cestu"
      Height          =   495
      Index           =   1
      Left            =   120
      TabIndex        =   2
      Top             =   7320
      Width           =   6975
   End
   Begin VB.PictureBox pic 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00E0E0E0&
      BorderStyle     =   0  'None
      Height          =   6495
      Left            =   120
      ScaleHeight     =   433
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   465
      TabIndex        =   1
      Top             =   720
      Width           =   6975
   End
   Begin MSComDlg.CommonDialog cmd1 
      Left            =   2400
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Load map"
      Filter          =   "*.txt"
   End
   Begin VB.CommandButton cmdS 
      Caption         =   "Otevt"
      Height          =   495
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8295
   End
   Begin MSComDlg.CommonDialog cmd2 
      Left            =   1560
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Save result"
      Filter          =   "*.txt"
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'' STARTOVNI CISLO 34

Option Explicit
Dim pole() As Byte ' pole do ktereho se ukladaji informace co je na mape
Const PoleVolno = 0
Const PolePrekazka = 1
Const PoleCil = 2
Const poleStart = 3
Const poleSilnice = 4
Dim pocetKroku
Dim MapWidth As Long, MapHeight As Long
Dim StartX As Long, StartY As Long
Dim CilX As Long, CilY As Long
Dim BestHistory As String
Private Type TpMapEntry
    rychlostX As Integer
    rychlostY As Integer
    kroku As Integer
End Type
Private Type TpBuffer
    x As Long
    y As Long
    rx As Integer
    ry As Integer
    kroku As Integer
    history As String
End Type
Private Type TpBuffer2
    x As Long
    y As Long
    oldX As Long
    oldY As Long
End Type
Private buffer() As TpBuffer
Private bufferU As Long
Dim Rozsah As Long

Private Sub cmdHelp_Click()
    MsgBox "Hledani cest" + vbCrLf + "Nejdrive otevrete mapu tlacitkem Otevrit, pak nechejte vyhledat cestu pomoci Najdi cestu. Vysledna cesta se vlozi do seznamu a je mozne je tlacitkem ulozit do textoveho souboru. " + vbCrLf + "Princip hledani cest zkousi rekurzivne simulovat pohyb s tim, ze uprednostnuje ponechani rychlosti a tedy rovnou caru a rychle vyhledani cile. Data, ktera nedokaze zpracovat jsou zapsana do bufferu a vyvolana pozdeji pri dalsi interaci. Pri dokonceni mapovani se zobrazi nejlepsi vysledek bilou carou.", vbInformation, "Napoveda"
End Sub

Private Sub cmdS_Click(Index As Integer)
    Select Case Index
    Case 0 ' otevrit
        cmd1.ShowOpen
        If cmd1.FileName <> vbNullString Then
            Dim aLine As String
            On Error GoTo ErrH:
            MapHeight = 0
            MapWidth = 0
            Rozsah = 0
            ' Nacteni mapy - dokaze i vetsi mapy nez 255x256
            Open cmd1.FileName For Input As #1
                Dim x As Integer, cilCnt As Long
                CilX = 0: CilY = 0: cilCnt = 0
                Do
                    Line Input #1, aLine
                    ' Delka radku se neschoduje s ostatnimi a je chyba
                    If MapWidth <> Len(aLine) And MapWidth <> 0 Then Err.Raise 0
                    MapWidth = Len(aLine)
                    ' Pri prvnim radku se spocita pocet celkovych radku
                    If MapHeight = 0 Then
                        ReDim pole(MapWidth - 1, Int(LOF(1) / (MapWidth + 2)) - 1)
                    End If
                    ' Dalsi radek
                    MapHeight = MapHeight + 1
                    For x = 0 To MapWidth - 1
                        pole(x, MapHeight - 1) = GetNumber(Mid(aLine, x + 1, 1))
                        If pole(x, MapHeight - 1) = poleStart Then StartX = x: StartY = MapHeight - 1
                        If pole(x, MapHeight - 1) <> PolePrekazka Then Rozsah = Rozsah + 1
                        If pole(x, MapHeight - 1) = PoleCil Then CilX = CilX + x: CilY = CilY + MapHeight - 1: cilCnt = cilCnt + 1
                    Next
                Loop While EOF(1) = False
                ' spocitame stred cilu
                CilX = CilX / cilCnt
                CilY = CilY / cilCnt
            Close #1
            ' Nakonec vykraslime mapu
            RenderMap
        End If
    Case 1 'najit cestu
        lstResult.Clear
        If MapWidth <> 0 Then FindWay
    End Select
    Exit Sub
    ' chyba - vynulovat parametry
ErrH:
    On Error Resume Next
    MsgBox "Chyba pri nacitani!", vbCritical
    MapWidth = 0
    MapHeight = 0
    StartX = 0
    StartY = 0
    ReDim pole(0, 0)
    RenderMap
    Close
End Sub
' znak ze souboru prevede na moje konstanty
Function GetNumber(s As String)
    Select Case s
    Case "X"
        GetNumber = PolePrekazka
    Case "."
        GetNumber = PoleVolno
    Case "S"
        GetNumber = poleStart
    Case "C"
        GetNumber = PoleCil
    Case ":"
        GetNumber = poleSilnice
    Case Else
        GetNumber = -1
    End Select
End Function

Private Sub cmdSave_Click()
    '' ulozeni vysledku
    cmd2.ShowSave
    If cmd1.FileName <> vbNullString Then
        Dim i As Integer
        Open cmd1.FileName For Output As #1
        For i = 0 To lstResult.ListCount - 1
            Print #1, lstResult.List(i)
        Next
        Close
    End If
End Sub

Private Sub Form_Load()
    cmd1.InitDir = App.Path
    cmd2.InitDir = App.Path
End Sub
' barevne vykresli mapu
Sub RenderMap()
    Dim rx As Single, ry As Single
    rx = pic.Width / (UBound(pole, 1) + 1)
    ry = pic.Height / (UBound(pole, 2) + 1)
    Dim x As Integer, y As Integer
    For x = 0 To UBound(pole, 1)
        For y = 0 To UBound(pole, 2)
            pic.Line (x * rx, y * ry)-(x * rx + rx, y * ry + ry), GetColor(pole(x, y)), BF
        Next
    Next
    pic.Refresh
End Sub
' urci barvu pro vykresleni bodu
Function GetColor(i As Byte)
    Select Case i
        Case PoleVolno
            GetColor = RGB(0, 128, 0)
        Case PolePrekazka
            GetColor = 0
        Case poleStart
            GetColor = RGB(128, 255, 255)
        Case PoleCil
            GetColor = vbMagenta
        Case poleSilnice
            GetColor = vbGreen
        Case Else
            Stop
    End Select
End Function


' hledaci algoritmus
Sub FindWay()
    ' inicializace
    Dim entry() As TpMapEntry
    ReDim entry(MapWidth - 1, MapHeight - 1)
        pocetKroku = 80
        ReDim buffer(0)
        ReDim buffer(256 ^ 2.5)
        bufferU = 0
        BestHistory = vbNullString
        'PRVNI FAZE - VYHLEDANI MOZNYCH BODU
        ' Nyni se vytvori seznam vsech moznych cest
        TryEntry entry, StartX, StartY, 0, 0, -30000, vbNullString
        Dim i As Long, ss As Long
        ss = 1
        Do Until ss > bufferU
            pocetKroku = pocetKroku + 80
            For i = ss To bufferU
                With buffer(i)
                TryEntry entry, .x, .y, .rx, .ry, .kroku, .history
                End With
            Next
            ss = i
        Loop
        ReDim buffer(0)
        'DRUHA FAZE - VYKRESLENI A ZAPSANI CESTY
        RenderMap
        Dim k As Integer, tmpSX As Integer, tmpSY As Integer, tmpPosX As Integer, tmpPosY As Integer, x As Integer, y As Integer
        tmpSX = 0: tmpSY = 0
        For k = 1 To Len(BestHistory) Step 2
            VyznacPole Asc(Mid(BestHistory, k, 1)), Asc(Mid(BestHistory, k + 1, 1)), vbWhite
            tmpPosX = Asc(Mid(BestHistory, k, 1))
            tmpPosY = Asc(Mid(BestHistory, k + 1, 1))
            If k = 1 Then x = tmpPosX: y = tmpPosY
            lstResult.AddItem (tmpPosX - x - tmpSX) & ", " & -(tmpPosY - y - tmpSY)
            tmpSX = tmpPosX - x
            tmpSY = tmpPosY - y
            
        Next
        
End Sub

Private Function TryEntry(ByRef entry() As TpMapEntry, x As Long, y As Long, rx As Integer, ry As Integer, ByVal kroku As Integer, ByVal history As String) As Boolean
    ''zapiseme historii
    history = history + Chr(x) + Chr(y)
    '' preteceni zasobniku vyresime zapsanim do buffer aby jsme se k tomu bodu mohli pozdeji vratit
    If kroku >= -30000 + pocetKroku Then
        AddBuff x, y, rx, ry, kroku, history
        TryEntry = True
        Exit Function
    End If
    ' tento bod se jiz probiral, proto se funkce ukonci
    If entry(x, y).kroku <> 0 Then Exit Function
    
    Dim et As TpMapEntry
    With entry(x, y)
        .kroku = kroku
        .rychlostX = rx
        .rychlostY = ry
    End With
    et = entry(x, y)
    entry(x, y).kroku = -30000
    ' nasli jsme cil a kontrolujeme jestli je cesta zatim ta nejlepsi
    If pole(x, y) = PoleCil Then
        If BestHistory = vbNullString Or Len(BestHistory) > Len(history) Then BestHistory = history
    End If

    kroku = kroku + 1
    VyznacPole x, y, RGB((Second(Time) Mod 10) / 10 * 128 + 128, 0, 0)
    Dim i As Integer, j As Integer, neco As Boolean, ii As Integer, jj As Integer
    i = 0: j = 0
    ii = 0: jj = 0
    ' prozkousime ostatni policka pro ryzne rychlosti
    With entry(x, y)
        If .rychlostX > 0 Then ii = 1
        If .rychlostX < 0 Then ii = -1
        If .rychlostY > 0 Then jj = 1
        If .rychlostY < 0 Then jj = -1
        ii = 0
        jj = 0
    End With
    If MoveAbleP(x + ii + entry(x, y).rychlostX, y + jj + entry(x, y).rychlostY, entry, kroku) = True And (entry(x, y).rychlostX <> 0 Or entry(x, y).rychlostY <> 0) Then _
        neco = TryEntry(entry, x + ii + entry(x, y).rychlostX, y + jj + entry(x, y).rychlostY, ii + entry(x, y).rychlostX, jj + entry(x, y).rychlostY, kroku, history)
    For i = -1 To 1
        For j = -1 To 1
            If i <> ii Or j <> jj Then
                If MoveAbleP(x + i + entry(x, y).rychlostX, y + j + entry(x, y).rychlostY, entry, kroku) = True Then _
                    neco = TryEntry(entry, x + i + entry(x, y).rychlostX, y + j + entry(x, y).rychlostY, i + entry(x, y).rychlostX, j + entry(x, y).rychlostY, kroku, history)
            End If
        Next j
    Next i
    ' nic nebylo nalezeno, rusi se cela vetev
    If neco = False Then
        TryEntry = False
        VyznacPole x, y, vbBlue
        entry(x, y).kroku = 0
        entry(x, y).rychlostX = 0
        entry(x, y).rychlostY = 0
    Else
        TryEntry = True
    End If
    entry(x, y).kroku = et.kroku
End Function

' vyznaci barevne pozadovane pole
Sub VyznacPole(x, y, col As Long)
    Dim rx As Single, ry As Single
    rx = pic.Width / (UBound(pole, 1) + 1)
    ry = pic.Height / (UBound(pole, 2) + 1)
    pic.Line (x * rx, y * ry)-(x * rx + rx, y * ry + ry), col, BF
    pic.Refresh
End Sub

' vraci zda je mozne se na pozadovane policko presunout + jestli jsme uz na nem nebyli rychleji
Private Function MoveAbleP(ByRef x, ByRef y, ByRef entry() As TpMapEntry, kroku As Integer) As Boolean
    If x < 0 Or y < 0 Or x >= MapWidth Or y >= MapHeight Then MoveAbleP = False: Exit Function
    Select Case pole(x, y)
        Case PolePrekazka
            MoveAbleP = False
        Case Else
            MoveAbleP = True
            If entry(x, y).kroku = -1 Then MoveAbleP = False
    End Select
End Function
' pridame do bufferu rozpracovany uzel
Sub AddBuff(x, y, rx, ry, kroku, history)
    bufferU = bufferU + 1
    With buffer(bufferU)
        .kroku = kroku
        .x = x
        .y = y
        .rx = rx
        .ry = ry
        .history = history
    End With
End Sub
